'****************************************************************************
'
' Spam-Proxy   : CONFIG.INC (configuration routines for SpamProxy)
' Version      : 0.03
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
'
'****************************************************************************


'-------------------------------------------------------------------------------------------
' Konfiguration aus dem CFG-File auslesen oder Ersatzzeile (Ex...) verwenden
'-------------------------------------------------------------------------------------------
FUNCTION Get_CfgEntry(BYVAL Cfg AS STRING, BYVAL Match AS STRING, BYVAL CfgDefault AS STRING, BYVAL XP AS LONG) AS STRING

        LOCAL CfgEntry     AS STRING      ' Cfg Settings
        LOCAL CfgTemp      AS STRING      '

        ' Testen ob erweiterter Eintrag den eigentlichen Eintrag ersetzt
        CfgEntry$ = Get_CfgLine(Cfg$, "Ex" + Match$, "", XP)

        IF CfgEntry$ = "" THEN
            CfgEntry$ = Get_CfgLine(Cfg$, Match$, CfgDefault$, XP)
        END IF

        FUNCTION = CfgEntry$

END FUNCTION

'-------------------------------------------------------------------------------------------
' Konfigurationszeile aus dem CFG-File auslesen
'-------------------------------------------------------------------------------------------
FUNCTION Get_CfgLine(BYVAL Cfg AS STRING, BYVAL Match AS STRING, BYVAL CfgDefault AS STRING, BYVAL XP AS LONG) AS STRING

        LOCAL LineEnd      AS INTEGER     '
        LOCAL LineEntry    AS STRING      ' Inhalt der Zeile
        LOCAL CfgEntry     AS STRING      ' Cfg Settings
        LOCAL CfgFound     AS INTEGER     '
        LOCAL P            AS INTEGER     ' Temp

        ON ERROR GOTO GetCfgLineError

        CfgFound% = %False

        REPLACE " =" WITH "=" IN Cfg$     ' eventl. "Pop3 = entry" filtern

        DO                                ' Search in Cfgfile
            LineEnd% = INSTR(Cfg$, Lf$)
            IF LineEnd% > 0 THEN
                LineEntry$ = REMOVE$(LEFT$(Cfg$, LineEnd% - 1), CHR$(13))
                Cfg$ = MID$(Cfg$, LineEnd% + 1)
                IF INSTR(UCASE$(LineEntry$), UCASE$(Match$)) = 1 THEN
                    CfgFound% = %True
                END IF
            END IF
        LOOP WHILE LineEnd% > 0 AND CfgFound% = %False

        IF CfgFound% = %True THEN
            p% = INSTR(LineEntry$, "=")               ' auf "=" parsen und alles dahinter
            IF p% > 0 THEN                            ' einlesen
                CfgEntry$ = MID$(LineEntry$, p% + 1)  '
            END IF
        END IF
        IF CfgEntry$ = "" OR INSTR(LCASE$(CfgEntry$), "incompatible") > 0 THEN
            CfgEntry$ = CfgDefault$
        END IF
        FUNCTION = CfgEntry$
        EXIT FUNCTION

GetCfgLineError:
        FUNCTION = "Cfg_Error"
END FUNCTION

'-------------------------------------------------------------------------------------------
' Konfigurationsflag ermitteln (enabled/disabled)
'-------------------------------------------------------------------------------------------
FUNCTION Get_CfgFlag(BYVAL Cfg AS STRING) AS LONG

        SELECT CASE LCASE$(Cfg$)
            CASE "enabled", "j", "y", "on", "ein", "true", "1"
                FUNCTION = %True
            CASE ELSE
                FUNCTION = %False
        END SELECT

END FUNCTION
